package net.bigeon.gclc.system;

import static org.junit.Assert.*;

import org.junit.Test;

import net.bigeon.gclc.exception.CommandRunException;
import net.bigeon.gclc.manager.ConsoleInput;
import net.bigeon.gclc.manager.ConsoleOutput;
import net.bigeon.gclc.utils.EmptyInput;
import net.bigeon.gclc.utils.SinkOutput;

public class ExecSystemCommandTest {

    @Test
    public void testExecSystemCommand() {
        ExecSystemCommand cmd = new ExecSystemCommand("test");
        assertEquals("Name should be preserved", "test", cmd.getCommandName());
        assertNotNull("tip should be defined", cmd.tip());
        assertNotNull("usage should be defined", cmd.usagePattern());
        assertNotNull("usage should be defined", cmd.usageDetail());
    }

    @Test
    public void testExecute() throws CommandRunException {
        ConsoleOutput out = SinkOutput.INSTANCE;
        ConsoleInput in = EmptyInput.INSTANCE;

        ExecSystemCommand cmd = new ExecSystemCommand();
        if (System.getProperty("os.name").contains("indows")) {
            cmd.execute(out, in, "cmd", "/C", "dir");
            try {
                cmd.execute(out, in, "inexistent");
                fail("Able to execute inexistent command in system");
            } catch (CommandRunException e) {
                // ok
            }
        }
    }

}
